
var discussPref = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefService)
                            .getBranch(null);

var isEditorLoaded = false;    // editor loaded flag
var editorHandle;              // Editor instance
var editorShell;               // editorShell instance
var rdfStore       = null;     // store the two datasource handle
var globalState    = null;     // abstract interface for all items, reflect in realtime
var postStore      = null;     // stuff to fill before saving in blogHistory datastore
var catManager     = null;     // cateogry manager, manage the category box
var postListBox    = null;     // the postlist box manager
//var LocalStrings = document.getElementById("bundle_MozBlog");
//Bundle Strins for MozBlog Localisation - Added by P.L. 01-01-03

initMozblog();

function initMozblog()
{
  rdfStore = new rdfRepository();
  loadRDF("discussProfile.rdf", "profile");
  loadRDF("blogHistory.rdf", "blogHistory");
}

function initObjects()
{
  globalState = new mozblogState();
  postStore   = new persistantStateStorage();
  catManager  = new categoryManager();
  postListBox = new prevPostBox();
}

function hideDoc()
{
  var doc = document.getElementById('bottomBar');
  var splitter = document.getElementById('discussSplit');
  if (doc.collapsed == false || splitter.collapsed == false)
  {
    doc.collapsed = true;
    splitter.collapsed = true;
    window._content.focus();
    document.getElementById('bottombarMenu').setAttribute('checked', 'false');
  } else {                        // open discuss
    doc.collapsed = false;
    splitter.collapsed = false;
    if (!isEditorLoaded) { // init editor instance if not already done so
      initObjects();
      editorHandle = new Editor("discussEditorType", "htmlEditor", "sourceEditor");
      populateBlogID();
      isEditorLoaded = true;
      var interval = window.setTimeout("postListBox.selectIndex(0)", 500);
      try {
        localStoreDir = discussPref.getCharPref("localstore.directory");
      } catch (ex) {
        alert (document.getElementById("bundle_MozBlog").getString("MozBlog.SetDefaultFolderBefore"));
      }
    }
    document.getElementById('bottombarMenu').setAttribute('checked', 'true');
    editorHandle.focus();
  }
}

function setDefaultView()
{
  try {
    var defaultView = discussPref.getBoolPref("discuss.defaultSourceView");
  } catch (e) {
    defaultView = false;
  }

  if (defaultView) { //if default as source view
    document.getElementById('sourceView').setAttribute("checked", true);
    editorHandle.viewSource();
  } else {
    document.getElementById('htmlView').setAttribute("checked", true);
    editorHandle.viewHtml();
  }
}

function statusReport(message)
{
  document.getElementById("statusbar-display").label = message;
}

//  var Bookmarks = Components.classes["@mozilla.org/browser/bookmarks-service;1"].getService(Components.interfaces.nsIRDFDataSource);
//  Bookmarks = Bookmarks.QueryInterface(Components.interfaces.nsIBookmarksService);

function testRegex()
{
  const kRDFContractID = "@mozilla.org/rdf/rdf-service;1";
  const kRDFIID = Components.interfaces.nsIRDFService;
  var RDF = Components.classes[kRDFContractID].getService(kRDFIID);
  var	Bookmarks = RDF.GetDataSource("rdf:localsearch");
//alert(document.getElementById("scraptDocument").value);
  var searchURI = "find:datasource=rdf:bookmarks&match=http://home.netscape.com/NC-rdf#Name&method=contains&text=mozilla";
  //var searchURI = "find:datasource=file:///c:/slashdot.xml&match=http://purl.org/rss/1.0/description&method=contains&text=s";
  var node = RDF.GetResource(searchURI);
  var kNC_child =  RDF.GetResource("http://home.netscape.com/NC-rdf#child");
  resultMarks= Bookmarks.GetTargets(node, kNC_child, true);
  alert(resultMarks.hasMoreElements())
    while (resultMarks.hasMoreElements()) {
    var child = resultMarks.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
    alert(child.Value);
  }
}