
var mozblogState = function() {}

mozblogState.prototype = {
  get content()	{
	return editorHandle.content;
  },
  set content(content) {
    editorHandle.content = content;
  },
  get title() {
    return document.getElementById("doctitle").value;
  },
  set title(title) {
    document.getElementById("doctitle").value = title;
  },
  get description() {
    return document.getElementById("docDescription").value;
  },
  set description(desc)	{
    document.getElementById("docDescription").value = desc;
  },
  get category() {
    var cat = document.getElementById("categoryBox").selectedItem;
    if (cat) return cat.value;
    else     return null;
  },
  set category(category) {
    this.contentCategory = category;
  },
  get postID() {
    var ds                               = rdfStore.getSource("blogHistory");
    var selectedResource                 = postListBox.selectedResource;
    if (selectedResource) this.contentID = getRDFAttribute(ds, selectedResource, "http://www.exitspace.net/blog/postid");
    else                  this.contentID = null;
    return this.contentID;
  },
  set postID(postId) {
    this.contentID = postId;
  },
  get published() {
    var ds                             = rdfStore.getSource("blogHistory");
    var selectedResource               = postListBox.selectedResource;
    if (selectedResource) this.publish = getRDFAttribute(ds, selectedResource, "http://www.exitspace.net/blog/published");
    else                  this.publish = null;
    return this.publish;
  },
  set published(status) {
    this.publish = status;
  },
  get permLink() {
    var selectedResource = postListBox.selectedResource;
    var ds = rdfStore.getSource("blogHistory");
    if (selectedResource) this.blogPermlink = getRDFAttribute(ds, selectedResource, "http://purl.org/rss/1.0/link");
    else                  this.blogPermlink = null;
    return this.blogPermlink;
  },
  set permLink(link) {
    this.blogPermlink = link;
  },
  get date() {
    var selectedResource = postListBox.selectedResource;
    var ds = rdfStore.getSource("blogHistory");
    if (selectedResource) this.blogDate = getRDFAttribute(ds, selectedResource, "http://purl.org/dc/elements/1.1/date");
    else                  this.blogDate = getISO8601Date(null);
    return this.blogDate;
  },
  set date(inDate) {
    this.blogDate = inDate;
  },
  get filename() {
    var selectedResource = postListBox.selectedResource;
    var ds = rdfStore.getSource("blogHistory");
    if (selectedResource) this.blogFilename = getRDFAttribute(ds, selectedResource, "http://www.exitspace.net/blog/filename");
    else                  this.blogFilename = getTimestamp(null) + ".html";
    return this.blogFilename;
  },
  get blogID() {
    return document.getElementById("blogIDs").selectedItem.value;
  },
  set blogID(blogId) {
	this.blogServerID = blogId;
  },
  clearState : function() {
    this.editorContent = null;
    this.contentTitle = null;
    this.contentDescription = null;
    this.contentCategory = null;
    this.contentID = null;
    this.blogServerID = null;
    this.blogPermlink = null;
    this.date = null;
    this.publish = null;
  }
}

var persistantStateStorage = function() {}

persistantStateStorage.prototype = {
  set content(content) {
    if (content) this.editorContent = content;
    else         this.editorContent = "";
  },
  set published(publish) {
    if (publish) this.contentPublished = publish;
    else         this.contentPublished = "N";
  },
  set filename(name) {
    if (name) this.contentFilename = name;
    else      this.contentFilename = "noname";
  },
  set title(title) {
    if (title) this.contentTitle = title;
    else       this.contentTitle = "";
  },
  set description(desc)	{
    if (desc) this.contentDescription = desc;
    else      this.contentDescription = "";
  },
  set category(category) {
    if (category) this.contentCategory = category;
    else          this.contentCategory = "";
  },
  set postID(postId) {
    if (postId) this.contentID = postId;
    else        this.contentID = "";
  },
  set permLink(link) {
    if (link) this.blogPermlink = link;
    else      this.blogPermlink = "";
  },
  set date(inDate) {
    if (inDate) this.blogDate = inDate;
    else        this.blogDate = "";
  },
  set blogID(blogId) {
	if (blogId) this.blogServerID = blogId;
    else        this.blogServerID = "";
  },
  saveToDisk : function() {
    if (this.contentID == null)
      return;

    var ds           = rdfStore.getSource("blogHistory");
    var saveBlogInfo = true;
    if (!this.blogDate) this.blogDate = getISO8601Date(null);
	var blogLoc      = "urn:date:" + this.blogDate;
    var RDF          = Components.classes['@mozilla.org/rdf/rdf-service;1']
                                 .getService(Components.interfaces.nsIRDFService);

    if (this.contentID != -1) { // if it's new post we skip this
      // get the sourceNode of postID, if exist it meant the node is already there
      // just the server got a different timestamp, so we ignore.
      try {
        var sourceNode = ds.GetSource(RDF.GetResource("http://www.exitspace.net/blog/postid"),
                                      RDF.GetLiteral(this.contentID), true);
      } catch (e) { dump("persistantStateStorage::saveToDisk error: contentID = "+this.contentID+"\n"+e); }
      if (sourceNode) {
        saveBlogInfo = false;
        var dateNode = ds.GetTarget(sourceNode, RDF.GetResource("http://purl.org/dc/elements/1.1/date"), true);
        // if date is same it meant the operation is a editpost, so we save blog info
        if (dateNode.Value == this.blogDate) {
          saveBlogInfo = true;
        }
      }
    }
    if (saveBlogInfo) {
      // somehow this.editorContent loses it's string methods like .length, so we add it back
      var fileContent  = new String(this.editorContent);
      var localStorage = new localStore(null);
      localStorage.saveFile(this.contentFilename, fileContent);
      setRDFAttribute(ds, blogLoc, "http://purl.org/rss/1.0/title",           this.contentTitle      , true);
      setRDFAttribute(ds, blogLoc, "http://purl.org/rss/1.0/description",     this.contentDescription, true);
      setRDFAttribute(ds, blogLoc, "http://purl.org/rss/1.0/link",            this.blogPermlink      , true);
      setRDFAttribute(ds, blogLoc, "http://purl.org/dc/elements/1.1/subject", this.contentCategory   , true);
      setRDFAttribute(ds, blogLoc, "http://www.exitspace.net/blog/postid",    this.contentID         , true);
      setRDFAttribute(ds, blogLoc, "http://purl.org/dc/elements/1.1/date",    this.blogDate          , true);
      setRDFAttribute(ds, blogLoc, "http://www.exitspace.net/blog/filename",  this.contentFilename   , true);
      setRDFAttribute(ds, blogLoc, "http://www.exitspace.net/blog/published", this.contentPublished  , true);
      ds.Assert(RDF.GetResource(blogLoc), RDF.GetResource("http://www.w3.org/1999/02/22-rdf-syntax-ns#type"),
                RDF.GetResource(this.blogServerID), true);
      addPostToList(ds, blogLoc);
      saveDatasource(ds);
    }
    ds = null;
    //    this.clearState();
  },
  snapState : function() {
    if (globalState.title == "" || globalState.title == " ")
      generateMetadata();
    this.content         = globalState.content;
    this.title           = globalState.title;
    this.description     = globalState.description;
    this.category        = globalState.category;
    this.postID          = globalState.postID;
    this.permLink        = globalState.permLink;
    this.date            = globalState.date;
    this.blogID          = globalState.blogID;
    this.contentFilename = globalState.filename;
    this.published       = globalState.published;
  },
  clearState : function() {
    this.contentID       = -1;
    this.blogServerID    = document.getElementById("blogIDs").selectedItem.value;
    this.contentFilename = getTimestamp(null) + ".html";
    this.blogDate        = getISO8601Date(null);
    this.contentID       = -1;
    this.published       = "N"
    this.editorContent   = "";
    this.contentTitle    = "";
    this.contentDescription = "";
    this.contentCategory = "";
    this.blogPermlink    = "";
  }
}

function generateMetadata()
{
  var whitespace = /\s+/gi;
  var htmlTag = /<[^<>]*>/gi;
  var stripContent = new String(editorHandle.content);//.replace(whitespace, " ");
  stripContent = stripContent.replace(htmlTag, "");

  var contentTitle = stripContent.slice(0,100);
  var lastFullStopIndex = contentTitle.lastIndexOf(".");
  if (lastFullStopIndex > 0)
    contentTitle = contentTitle.slice(0,lastFullStopIndex+1);
  document.getElementById("doctitle").value = contentTitle;

  var contentDescription = stripContent.slice(0,500);
  var lastFullStopIndexDesc = contentDescription.lastIndexOf(".");
  if (lastFullStopIndexDesc > 0)
    contentDescription = contentDescription.slice(0,lastFullStopIndexDesc+1);
  document.getElementById("docDescription").value = contentDescription
}

// transform the title into a valid filename
function transformTitle(title)
{
  var invalidChar = /\/|\\|:|\*|\?|<|>|\|/gi;
  if(title.length != 0)	{
	title = title.replace(invalidChar, "");
    title = title.replace(/\s+/gi, "_");
	if (title.charAt(title.length-1) == '_')
      title = title.substring(0, title.length - 1);
  } else {
    title = getISO8601Date(null);
  }
  return title;
}

// add the post link to the list of history
function addPostToList(ds, titleKey)
{
  var RDF          = Components.classes['@mozilla.org/rdf/rdf-service;1']
					           .getService(Components.interfaces.nsIRDFService);
  var RDFContainer = Components.classes["@mozilla.org/rdf/container;1"]
	   		                   .getService(Components.interfaces.nsIRDFContainer);
  var RDFContainerUtils = Components.classes["@mozilla.org/rdf/container-utils;1"]
                               .getService(Components.interfaces.nsIRDFContainerUtils);
  var blogPostList = RDF.GetResource('http://www.exitspace.net/blog/posts');
  if (!RDFContainerUtils.IsContainer(ds, blogPostList))
  {
    RDFContainer = RDFContainerUtils.MakeBag(ds, blogPostList);
  }
  RDFContainer.Init(ds, blogPostList);
  var index = RDFContainer.IndexOf(RDF.GetResource(titleKey));
  if (index == -1) {// none existed
    var insertLocation = 1;
    var itemEnum = RDFContainer.GetElements();
    RDFContainer.AppendElement(RDF.GetResource(titleKey));
  } else return false;
  ds = null;
  return true;
}

function getTimestamp(inDate)
{
  var date
  if (inDate)
    date = new Date(inDate);
  else
    date = new Date();
  return date.valueOf();
}

function getISO8601Date(inDate)
{
  var date
  if (inDate)
    date = new Date(inDate);
  else
    date = new Date();
  var dateString = "";
  dateString = date.getFullYear() + "-";
  date.getMonth() + 1 < 10 ? dateString += "0" + (date.getMonth() + 1) + "-" : dateString += date.getMonth() + 1 + "-";
  date.getDate()      < 10 ? dateString += "0" + date.getDate() + "T" : dateString += date.getDate() + "T";
  date.getHours()     < 10 ? dateString += "0" + date.getHours() + ":" : dateString += date.getHours() + ":";
  date.getMinutes()   < 10 ? dateString += "0" + date.getMinutes() + ":" : dateString += date.getMinutes() + ":";
  date.getSeconds()   < 10 ? dateString += "0" + date.getSeconds() + "" : dateString += date.getSeconds() + "";

  var offsetHours = date.getTimezoneOffset() / 60;
  var offsetMinute = date.getTimezoneOffset() % 60;
  if (offsetHours > 0)
    offsetHours < 10 ? dateString += "+0" + offsetHours + ":" : dateString += "+" + offsetHours + ":";
  else
    offsetHours > -10 ? dateString += "0" + offsetHours + ":" : dateString += offsetHours + ":";
  offsetMinute < 10 ? dateString += "0" + offsetMinute : dateString += offsetMinute;

  return dateString;
}
