  var statusMessage = "";
  var done = false;

  var httpRequest;
  var currentSiteContent;     // sites full html content retrieved
  var siteList = new Array(); // site url array
  var siteIndex = 0;
  var currentSiteUrl = "";

  var uncertainSize = 60
  var chunkSize     = 0;

  var xmlRpcClient;
  var xmlRpc = getXmlRpc();

  var ds  = getRDFHandle("discussProfile.rdf");
  var RDF = Components.classes['@mozilla.org/rdf/rdf-service;1']
                      .getService(Components.interfaces.nsIRDFService);

  var blogSrvUrlNS       = RDF.GetResource("http://www.exitspace.net/blog/serverUrl");
  var blogAppKeyNS       = RDF.GetResource("http://www.exitspace.net/blog/appKey");
  var blogUserNameNS     = RDF.GetResource("http://www.exitspace.net/blog/username");
  var blogPingBlogNS     = RDF.GetResource("http://www.exitspace.net/blog/pingBlog");
  var blogRetrieveNumNS  = RDF.GetResource("http://www.exitspace.net/blog/retrieveNum");
  var blogTypeNS         = RDF.GetResource("http://www.exitspace.net/blog/blogType");
  var BlogSrvContainerNS = null;
  const DEBUG = true;
  //var MozBlogLocalStr = document.getElementById("bundle_MozBlog");
  //Bundle Strins for MozBlog Localisation - Added by P.L. 01-01-03

  // function to load all the details when user click edit button ////////////////////////////////////
  function loadPref()
  {
	if (opener.selectedServer) {
      var BlogSrvContainerNS = RDF.GetResource(opener.selectedServer);
      var RDFContainer       = Components.classes["@mozilla.org/rdf/container;1"]
                                         .getService(Components.interfaces.nsIRDFContainer);
      // change to the default selection
      try {
        var blogType = getTargetValue(BlogSrvContainerNS, blogTypeNS);
      } catch (e) {
        blogType = "none";
      }
      var blogEntryArray = document.getElementById("blogType").firstChild.childNodes;
      if (blogType)
        for (var i = 0; i < blogEntryArray.length; i++)
          if (blogType == blogEntryArray[i].getAttribute("value")) {
            document.getElementById("blogType").selectedIndex = i;
            showBlogType(document.getElementById("blogType").getAttribute("value"));
          }	  
          setTextFieldValue("bloggerServer", getTargetValue(BlogSrvContainerNS, blogSrvUrlNS));
	  setTextFieldValue("bloggerAppkey", getTargetValue(BlogSrvContainerNS, blogAppKeyNS));
	  setTextFieldValue("bloggerUser", getTargetValue(BlogSrvContainerNS, blogUserNameNS));
	  setTextFieldValue("retrievePost", getTargetValue(BlogSrvContainerNS, blogRetrieveNumNS));
	  setTextFieldValue("bloggerPassword", loadPassword(getTargetValue(BlogSrvContainerNS, blogSrvUrlNS),
										   getTargetValue(BlogSrvContainerNS, blogUserNameNS)));
	  if (getTargetValue(BlogSrvContainerNS, blogPingBlogNS) == "true")
		document.getElementById("pingBlog").checked = true;
	  else
		document.getElementById("pingBlog").checked = false;
	}
  }

  // save the currently selected server settings into rdf ///////////////////////////////////////////////
  function saveServerInfo()
  {
	document.getElementById("panelDeck").setAttribute("selectedIndex", 1);
	//document.getElementById("channelDialog").getButton("accept").setAttribute("disabled", "true");
    document.getElementById("accept").setAttribute("disabled", "true");

    var blogTypeValue      = document.getElementById("blogType").selectedItem.value;
    var blogServerUrl      = document.getElementById("bloggerServer").value;
    var blogUser           = document.getElementById("bloggerUser").value;
    BlogSrvContainerNS = RDF.GetResource(blogServerUrl + "#" + blogUser);

	addNode(BlogSrvContainerNS, blogSrvUrlNS,      RDF.GetLiteral(getTextFieldValue("bloggerServer")));
	addNode(BlogSrvContainerNS, blogAppKeyNS,      RDF.GetLiteral(getTextFieldValue("bloggerAppkey")));
	addNode(BlogSrvContainerNS, blogUserNameNS,    RDF.GetLiteral(getTextFieldValue("bloggerUser")));
	addNode(BlogSrvContainerNS, blogRetrieveNumNS, RDF.GetLiteral(getTextFieldValue("retrievePost")));
    addNode(BlogSrvContainerNS, blogTypeNS,        RDF.GetLiteral(blogTypeValue));

	if (document.getElementById("pingBlog").checked)
	  addNode(BlogSrvContainerNS, blogPingBlogNS, RDF.GetLiteral("true"));
	else
	  addNode(BlogSrvContainerNS, blogPingBlogNS, RDF.GetLiteral("false"));

	savePassword(getTextFieldValue("bloggerServer"), getTextFieldValue("bloggerUser"),
				 getTextFieldValue("bloggerPassword"));

    if (document.getElementById("blogType").selectedItem.value == "radio")
      addRadioSiteID();
    else
      getUserBlog();

	return false; // don't close the window just yet
  }

  // add the site ID to the list for the selected server. //////////////////////////////////////////////////
  // also populate the site dropdown in the process
  // para1 = the blogInfo hash from blogger api
  // para2 = the site ID list to insert the site to
  function addSiteIDtoList(blogInfo, RDFContainer)
  {
    var blogSiteID;
    var blogName;
    var blogUrl;
    try {
	  blogSiteID = blogInfo.getValue("blogid").QueryInterface(Components.interfaces.nsISupportsString);
	  blogName   = blogInfo.getValue("blogName").QueryInterface(Components.interfaces.nsISupportsString);
	  blogUrl    = blogInfo.getValue("url").QueryInterface(Components.interfaces.nsISupportsString);
    } catch (e) {
	  blogSiteID = blogInfo.getValue("blogid").QueryInterface(Components.interfaces.nsISupportsCString);
	  blogName   = blogInfo.getValue("blogName").QueryInterface(Components.interfaces.nsISupportsCString);
	  blogUrl    = blogInfo.getValue("url").QueryInterface(Components.interfaces.nsISupportsCString);
    }
        var MozBlogLocalStr = document.getElementById("bundle_MozBlog");

	statusMessage += MozBlogLocalStr.getString("MozBlog.Found") + ": " + blogName;
	document.getElementById("messageBox").value = statusMessage;

	var BlogSrvNS      = RDF.GetResource("http://www.exitspace.net/blog/blogServer");
	var blogSiteIDNS   = RDF.GetResource("http://www.exitspace.net/blog/siteID");
	var blogSiteNameNS = RDF.GetResource("http://www.exitspace.net/blog/siteName");
	blogName           = RDF.GetLiteral(blogName);
	blogSiteID         = RDF.GetLiteral(blogSiteID);
	blogUrl            = RDF.GetResource(blogUrl);

    ds.Assert(blogUrl, blogSiteIDNS, blogSiteID, true);
    ds.Assert(blogUrl, blogSiteNameNS, blogName, true);
    ds.Assert(blogUrl, BlogSrvNS, BlogSrvContainerNS, true);

	RDFContainer.AppendElement(blogUrl);
  }

  function addRadioSiteID()
  {
    var MozBlogLocalStr = document.getElementById("bundle_MozBlog");
    statusMessage += MozBlogLocalStr.getString("MozBlog.AddingRadioBlogServer");
    document.getElementById("progressBar").setAttribute("mode","determined");
    document.getElementById("progressBar").setAttribute("value","20");

    var blogSiteID     = RDF.GetLiteral(document.getElementById("bloggerID").getAttribute("value"));
    var blogName       = RDF.GetLiteral("My Radio");
    var blogUrl        = RDF.GetResource("http://127.0.0.1:5335/");
    var BlogSrvNS      = RDF.GetResource("http://www.exitspace.net/blog/blogServer");
    var blogSiteIDNS   = RDF.GetResource("http://www.exitspace.net/blog/siteID");
    var blogSiteNameNS = RDF.GetResource("http://www.exitspace.net/blog/siteName");

	ds.Assert(blogUrl, blogSiteIDNS, blogSiteID, true);
	ds.Assert(blogUrl, blogSiteNameNS, blogName, true);
	ds.Assert(blogUrl, BlogSrvNS, BlogSrvContainerNS, true);

    var RDFContainer = openSiteIDList(ds);
	RDFContainer.AppendElement(blogUrl);
    document.getElementById("progressBar").setAttribute("value","95");

    finalise();
  }

  // xmlrpc call to get the bloginfo, returing url, blogname, and blogid /////////////////////////////////
  function getUserBlog()
  {
	//if (done == false) {
      document.getElementById("progressBar").setAttribute("mode","undetermined");

          var MozBlogLocalStr = document.getElementById("bundle_MozBlog");
	  statusMessage += MozBlogLocalStr.getString("MozBlog.Server") + getTextFieldValue("bloggerServer");
	  statusMessage += MozBlogLocalStr.getString("MozBlog.UsernamePassword") +
                           getTextFieldValue("bloggerUser") +
                           MozBlogLocalStr.getString("MozBlog.Hidden");
	  document.getElementById("messageBox").value = statusMessage;

	  var serverurl   = xmlRpc.createType(xmlRpc.STRING, {});
	  var blogAppkey  = xmlRpc.createType(xmlRpc.STRING, {});
	  var username    = xmlRpc.createType(xmlRpc.STRING, {});
	  var password    = xmlRpc.createType(xmlRpc.STRING, {});

      serverurl.data  = getTextFieldValue("bloggerServer");
	  blogAppkey.data = getTextFieldValue("bloggerAppkey");
	  username.data   = getTextFieldValue("bloggerUser");
	  password.data   = getTextFieldValue("bloggerPassword");

	  xmlRpc.init(serverurl);
	  xmlRpc.asyncCall(blogInfoListener, null, "blogger.getUsersBlogs",
                       [blogAppkey, username, password], 3);
          /*if (DEBUG) {
            document.getElementById("messageBox").value = 'Response String: ' + xmlRpc.responseString();
          }*/
	  done = true;
	//}
  }

  // listener for getUserBlog() use call addSiteIDtoList() to save info /////////////////////////////////
  var blogInfoListener = {
	onResult: function(client, ctxt, result) {
	  var localRDS = ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	  if (localRDS.loaded)
	  {
        document.getElementById("progressBar").setAttribute("mode","determined");
        document.getElementById("progressBar").setAttribute("value","80");
		var RDFContainer = openSiteIDList(ds);

		var blogInfoResult = result.QueryInterface(Components.interfaces.nsISupportsArray);
                var MozBlogLocalStr = document.getElementById("bundle_MozBlog");
        if (blogInfoResult.Count() < 1)
          alert(MozBlogLocalStr.getString("MozBlog.NoAccountExists"));

		for (i = 0; i < blogInfoResult.Count(); i++) {
		  var blogInfo = blogInfoResult.QueryElementAt(i, Components.interfaces.nsIDictionary);
		  addSiteIDtoList(blogInfo, RDFContainer);
          siteList[i] = blogInfo;
		}

        statusMessage += MozBlogLocalStr.getString("MozBlog.SavingDetails");
        document.getElementById("messageBox").value = statusMessage;
        document.getElementById("progressBar").setAttribute("value","95");
        finalise();
      }
	}, onFault: function(client, ctxt, fault) {
	  alert(document.getElementById("bundle_MozBlog").getString("MozBlog.Fault") + fault + "\n");
	}, onError: function(client, ctxt, status, errorMsg) {
	  alert(document.getElementById("bundle_MozBlog").getString("MozBlog.Error") + status.toString(16) + ") " + errorMsg + "\n");
	}
  };

  // open the site id list. If the list don't exist, it's created. //////////////////////////////////////
  // If it does it delete all prior entry with the right blogServer
  function openSiteIDList(ds)
  {
	var RDFContainer = Components.classes["@mozilla.org/rdf/container;1"]
								 .getService(Components.interfaces.nsIRDFContainer);
	var RDFContainerUtils = Components.classes["@mozilla.org/rdf/container-utils;1"]
									  .getService(Components.interfaces.nsIRDFContainerUtils);

	var BlogSrvNS          = RDF.GetResource("http://www.exitspace.net/blog/blogServer");
	var blogSiteListNS     = RDF.GetResource('http://www.exitspace.net/blog');

	if (!RDFContainerUtils.IsContainer(ds, blogSiteListNS)) {
	  RDFContainer = RDFContainerUtils.MakeSeq(ds, blogSiteListNS);
	}
	RDFContainer.Init(ds, blogSiteListNS);

	// get the entries with the right blogServer
	var blogIDsForThisServer = ds.GetSources(BlogSrvNS, BlogSrvContainerNS, true);
	while(blogIDsForThisServer.hasMoreElements()) {
	  var blogIDElement = blogIDsForThisServer.getNext();
	  blogIDElement     = blogIDElement.QueryInterface(Components.interfaces.nsIRDFResource);
	  RDFContainer.RemoveElement(blogIDElement, true);
	}

	return RDFContainer;
  }

  // save the data source, repopulate the blog list, then wait one second before closing
  function finalise()
  {
    var localRDS = ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
    localRDS.Flush();
    ds = null;
    window.opener.populateServer();
    setTimeout("window.close();", 500);
  }

  // utility functions /////////////////////////////////////////////////////////////////////////////////////
  function getTargetValue(subject, attribute)
  {
	return ds.GetTarget(subject, attribute, true)
			 .QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
  }

  function setTextFieldValue(inputName, value)
  {
	document.getElementById(inputName).setAttribute("value", value);
  }

  function getTextFieldValue(inputName)
  {
	return document.getElementById(inputName).value;
  }

  // add a statement. If old value exist, change it. Else create a new one
  function addNode(subject, predicate, newValue)
  {
	var oldValue = ds.GetTarget(subject, predicate, true);
	if(oldValue) {
	  ds.Change(subject, predicate, oldValue, newValue);
	} else {
	  ds.Assert(subject, predicate, newValue, true)
	}
  }

  function getClient() {
	return Components.classes["@mozilla.org/xml-rpc/client;1"]
					 .createInstance(Components.interfaces.nsIXmlRpcClient);
  }

  function getXmlRpc() {
	if (!xmlRpcClient) xmlRpcClient = getClient();
    return xmlRpcClient;
  }


  function loadPage()
  {
    p.open("GET", "http://www.samrowe.com/slb/mozblog.php");
    p.send(null);
    //window.open("http://www.samrowe.com/slb/mozblog.php");
  }

  function myfunc(e)
  {
    var parser = new DOMParser();
    //var doc = parser.parseFromString(p.responseText, "text/xml");
    var doc = p.responseXML;
    //var forms = doc.getElementsByTagName("form");
    alert(doc.nodeName);
    /*if (p.responseXML) {
      var s = new XMLSerializer();
      var d = p.responseXML;
      var str = s.serializeToString(d);
      alert(str);
    }*/
  }

  var p = new XMLHttpRequest();
  p.onload = myfunc;